BEGIN {
  jump = 0 ;
}
/#/ { next ; }
/JUMP/ {
  JUMP = 1 ; 
  jumplabel = $2 ;
} 
/:[a-zA-Z0-9]+/ {
  if (substr($1,2) == jumplabel) 
    JUMP = 0;
  next ;
}
/:=/ {
  if (JUMP == 1 ) next ;
  if (no != 0) {
    dothings();
  }

  allfc2 = "" ;
  for (i=3; i<= NF; i++) {
    allfc2 = allfc2 " " $i ;
  }
  cmd = "composefc2 " $1 " " allfc2 ;
  print "----------------------------------------------"
  print " DO " $0 ;
  print "----------------------------------------------"
  print "executing..." cmd;
  system(cmd);
  newfile = $1 ;
  no = 0 ;
}
/@/ {
  if (JUMP == 1) next ;
  from[no] = $2 ;
  to[no] = $3 ;
  no ++ ;

}
/BREAK/ {
  if (JUMP == 1) next ;
  if (no != 0) {
    dothings();
  }
  exit 0 ;
}

END {
  if (no != 0) {
    dothings();
  }
}
function dothings() {
    #   first translate fc2 to dot
    cmd = "fc2dot " newfile ".fc2 " newfile ".dot" ;
    print "executing..." cmd;
    system(cmd);
    
#   purge (context constraint) by 
    cmd = "dotpurge " newfile ".dot " newfile ".X.dot @ " ;
    for (j=0;j<no; j++) {
      cmd = cmd from[j] " " to[j] " @ " ;
    }
    print "executing..." cmd;
    system(cmd);
    
#   translate back to fc2    
    cmd = "dot2fc2 " newfile ".X.dot " newfile ".X.fc2" ;
    print "executing..." cmd;
    system(cmd);

#   backup 
    cmd = "cp " newfile ".X.fc2 " newfile ".fc2" ;
    print "executing..." cmd;
    system(cmd);

#   minimize the fc2
    
    cmd = "minfc2 -b " newfile ".fc2 " newfile
    print "executing..." cmd;
    system(cmd);

    cmd = "rm " newfile ".dot " newfile ".X.dot " newfile ".X.fc2 "
    print "executing..." cmd;
    system(cmd);
    no = 0 ;
}


