#
#  when a .fc2 file is produced by fc2explicit
#  its header is like
#  nets 1
#  net 0
#  S1
#  :0 "xxx"
#  B4 
#  :0 "aaaa"
#  :1 "bbbb"
#
#   for some reasons, this net cannot be read by fc2link
#  we must fix it to 
#    struct"axxxx"
#    net 0
#    B4 
BEGIN { 
  structcoming = 0 ;
}
/net 0/ { next ; }
/S1/ {
  structcoming = 1 ;
  next ;
}
/:[0-9]+/ { 
  if (structcoming == 1) {
    structcoming = 0 ;
    print "struct " $2 ;
    print "net 0" ;
    next ;
  }
}
/./ { print ; }
