#-------------------------------------------------------
# getsubtask.awk
# 
# This program is called by composefc2. You should not
# call it directly.
# 
#     gawk -f rename.awk newsub_net.fc2
#
#  This awk script is called by passing the net fc2 file
#  This script collects all the sub task names in the net file
#  
#-------------------------------------------------------
BEGIN {
  netcoming = 0 ;
}
/nets/ { 
  if ($2 == 1) {
#  this is not a net file
    print "ERROR: file " FILENAME " is not a fc2 net file! " ;
    print "       please solve the problem " ;
    exit 1;
  }
  print "TASKLIST" ;
  next ;
}
/net +[0-9]+/ { 
  if ($2 != 0 ) 
    netcoming = 1 ;
  next ;
}
/struct/ {
  netname = substr($0, match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
  purenetname = substr(netname,2,RLENGTH-2);
  next ;
}
/:[0-9]+/ {
  if (netcoming==1) {
    netname = substr($0, match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
    purenetname = substr(netname,2,RLENGTH-2);
    netcoming = 0 ;
    print purenetname ;
    next ;
  }
}

