/**
  * node.java
  * 
  * By Yung-Pin Cheng 10/28/1998
  *
  */

import java.lang.* ;
import java.util.* ;
class node {
  int eno = 0 ;
  String name ;
  boolean initial = false ;
  boolean visited ;
  boolean deleted ;
  String[] to = new String[5] ;
  int[] ename = new int[5] ;
  boolean[] edgedeleted = new boolean[5] ;
  BitSet[] histarray = null ;
  
  //constuctor
  
public node(String node_name, boolean init) { 
  name = node_name ;
  initial = init ;
}

public void addEdge(int eindex, String tostr) {
  int[] newname ;
  String[] newto ;
  boolean[] newdeleted ;
  int i ;

  if (eno >= ename.length) {
    // there are more than initial array size 
    // adjust the array size and copy data 
    newname = new int[ename.length + 5] ;
    newto =   new String[to.length+ 5] ;
    newdeleted = new boolean[edgedeleted.length + 5 ];
    for (i=0;i < ename.length ; i++) {
      newname[i] = ename[i] ;
      newto[i] =   to[i] ;
      newdeleted[i] = edgedeleted[i] ;
    }
    ename = newname ;
    to = newto ;
    edgedeleted = newdeleted ;
  }
  
  ename[eno] = eindex ;
  to[eno] = tostr ;
  edgedeleted[eno] = false ;
  eno ++ ;
}

public String toString(Hashtable edget) {
  String tmp ;
  int i = 0 ;
  if (deleted) return ""  ;
  tmp = new String("\""+ name + "\" [shape = ");
  if (initial) 
    tmp = tmp.concat("box , style = filled, color = blue]; \n");
  else
    tmp = tmp.concat("ellipse, style = filled, color = white];\n");
  for (i=0;i< eno; i++) {
    if (!edgedeleted[i]) {
      tmp = tmp.concat("\""+ name + "\" -> \""+ to[i] + "\" ");
      if (ename[i] == 0) 
	tmp = tmp.concat("[ label = \"" + 
			 (String) edget.get(new Integer(ename[i])) +
			 "\", color = gold ];\n");
      else 
	tmp = tmp.concat("[ label = \"" + 
			 (String) edget.get(new Integer(ename[i])) +
			 "\"];\n") ;
    }
  }
  return tmp ;

}
   
      
      

  
  
}
    
    
  
  

  
