BEGIN {
  no = 0 ;
  err = 0
}
/RENAME/ { next ; }
/./ { 
  if (search($1,$2) != -1) 
    err = 1 ;
  oldname[no] = $1 ;
  newname[no] = $2 ;
  no ++ ;
  
}
END {
  if (err == 1) {
    print " " ;
    print "       for example: " ;
    print "       Suppose you have two ports a1XXstart, a2XXstart    " ;
    print "       in the new subsystem called b. They will both      " ;
    print "       be renamed to bXXstart                             " ;
    print "       To avoid it, change a1XXstart into a1XXstarta1     ";
    exit 1 ;
  }
  
}
       

function search(old,new) {
  for (i=0;i< no; i++) {
    if (new == newname[i]) {
      print "----------------------------------------------------------" ;
      print "ERROR: portname:" oldname[i] " and " old  ;
      print "       are renamed into a same name " new ;
      return i;
    }
  }
  return -1 ;
}
   
